public class CodeExchange{
	private String Base64Code="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	
	///////////////////////////////////////////////////////////////////////////
	//	ASCII  Base64 GR[h
	//
	public int EncodeBase64(char[] Source,int Length,char[] result){
		int retsts=0;
		int i,j;
		int ResultCount=0;
		int length;
		char[] source=new char[Length+1];
		
		for(i=0;i<Length;i++)	source[i]=Source[i];
		length=Length;
		if(0<Length%3)	source[length++]=0x00;
		
		for(i=0;i<length;i++){
			switch(i%3){
			case 0:
				result[ResultCount++]=Base64Code.charAt(                           source[i]>>2 );
				break;
			case 1:
				result[ResultCount++]=Base64Code.charAt(((source[i-1] & 0x03)<<4)+(source[i]>>4));
				break;
			case 2:
				result[ResultCount++]=Base64Code.charAt(((source[i-1] & 0x0f)<<2)+(source[i]>>6));
				result[ResultCount++]=Base64Code.charAt(  source[i  ] & 0x3f                    );
				break;
			}
		}
		
		switch(Length%3){
		case 0:
			break;
		case 1:
			result[ResultCount++]=Base64Code.charAt(64);
			result[ResultCount++]=Base64Code.charAt(64);
			break;
		case 2:
			result[ResultCount-1]=Base64Code.charAt(64);
			break;
		}
		
		retsts=ResultCount;
		return retsts;
	}
	
	///////////////////////////////////////////////////////////////////////////
	//	ASCII  Base64 fR[h
	//
	public int DecodeBase64(char[] Source,int Length,char[] result){
		int retsts=0;
		int i,j;
		char[] source=new char[Length];
		int length     =0;
		int noCount    =0;
		int ResultCount=0;
		
		for(i=0;i<Length;i++){
			j=Base64Code.indexOf(Source[i]);
			if(0<=j){
				source[length++]=(char)(j%64);
				if(j==64)	noCount++;
			}
		}
		
		for(i=3;i<length;i+=4){
			result[ResultCount++]=(char)(( source[i-3]        <<2)+(source[i-2]>>4));
			result[ResultCount++]=(char)(((source[i-2] & 0x0f)<<4)+(source[i-1]>>2));
			result[ResultCount++]=(char)(((source[i-1] & 0x03)<<6)+ source[i  ]    );
		}
		
		retsts=ResultCount-noCount;
		return retsts;
	}
	
	///////////////////////////////////////////////////////////////////////////
	//	URIUTF8R[hHEXR[hɕϊ
	//	"http://www.google.co.jp/search?hl=ja&q=%E6%97%A5%E6%9C%AC%E8%AA%9E&lr="
	//		
	//	"http://www.google.co.jp/search?hl=ja&q={&lr="
	//
	public String decodeUri(String uri){
		String retstr="";
		byte[] source=new byte[1024];
		String str1;
		char ch;
		int i,j,k;
		
		for(i=0;i<uri.length();i++){
			str1=uri.substring(i,i+1);
			if(str1.equals("%")&&i<=uri.length()-2){
				for(j=i,k=0;j<uri.length();j+=3){
					if(uri.charAt(j)=='%')	source[k++]=(byte)hex2int(uri.substring(j+1,j+3));
					else{
						try{
							str1=new String(source,0,k+1,"UTF8");
							if(str1.length()==1)	retstr+=str1.substring(0,str1.length());
							else					retstr+=str1.substring(0,str1.length()-1);
						}
						catch(Exception e){
						}
						i=j-1;
						break;
					}
				}
			}
			else	retstr+=str1;
		}
		return retstr;
	}
	
	///////////////////////////////////////////////////////////////////////////
	//	(String)16i(int)10i ϊ\bh
	//
	public int hex2int(String hex){
		int ret=0,i;
		char ch;
		for(i=0;i<hex.length();i++){
			ch=hex.charAt(i);
			if     ('0'<=ch && ch<='9'){	ret*=16;	ret+=ch-'0';	}
			else if('A'<=ch && ch<='F'){	ret*=16;	ret+=ch-'A'+10;	}
			else if('a'<=ch && ch<='f'){	ret*=16;	ret+=ch-'a'+10;	}
			else	break;
		}
		return ret;
	}
	
	///////////////////////////////////////////////////////////////////////////
	//	(int)10i(String)16i ϊ\bh
	//
	public String int2hex(int num){	return int2hex(num,0);	}	//	OverWrite
	public String int2hex(int num,int keta){
		String retstr="";
		int i=num,j,k=0;
		String HexStr="0123456789ABCDEF";
		
		while(i!=0){
			j=i%16;
			retstr=HexStr.substring(j,j+1)+retstr;
			i=(i-j)/16;
			k++;
		}
		if(k<keta)	retstr=("0000000000"+retstr).substring(10+k-keta);
		return retstr;
	}
}
