///////////////////////////////////////////////////////////////////////////////////////
//
//	t@CNX
//
//	public String  FileRead( String filename);				//	t@CǍ
//	public String  FileWrite(String filename,String data);	//	t@C
//	public String  FileAdd(  String Filename,String data);	//	t@CǋL
//	public String  FileDel(  String Filename);				//	t@C폜
//	public boolean FileExist(String Filename);				//	t@C݃`FbN
//	public int     FileType(String Filename);				//	t@Cޔ
//	public String  FileSearch(String path);					//	t@CXg\bh
//	public String  FileSort(  String data);					//	t@CXg\[g
//
///////////////////////////////////////////////////////////////////////////////////////

import java.text.*;
import java.util.*;
import java.io.*;

public class FileTools{
	
	/////////////////////////////////////////////////////////////////////////////////
	//	t@CǍ
	//
	public String FileRead(String filename){
		String retmsg="",str;
		try{
			File file = new File(filename);
			FileInputStream   in1=new FileInputStream(file);
			InputStreamReader in2=new InputStreamReader(in1,"SJIS");
			BufferedReader    in3=new BufferedReader(in2);
			while(true){
				str=in3.readLine();
				if(str==null)	break;
				retmsg+=str+"\n";
			}
			in3.close();
		}
		catch(Exception e){
			retmsg="";
		}
		return retmsg;
	}
	
	/////////////////////////////////////////////////////////////////////////////////
	//	t@C
	//
	public String FileWrite(String filename,String data){
		String retmsg="";
		try{
			FileOutputStream out=new FileOutputStream(filename);
			PrintWriter writer=new PrintWriter(out);
			writer.print(data);
			writer.flush();
			writer.close();
			retmsg="0";
		}
		catch(Exception e){
			retmsg="-1";
		}
		return retmsg;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	t@CǋL
	//
	public String FileAdd(String filename,String data){
		String retmsg="";
		try{
			FileOutputStream out=new FileOutputStream(filename,true);
			PrintWriter writer=new PrintWriter(out);
			writer.print(data);
			writer.flush();
			writer.close();
			retmsg="0";
		}
		catch(Exception e){
			retmsg="-1";
		}
		return retmsg;
	}
	
	/////////////////////////////////////////////////////////////////////////////////
	//	t@C폜
	//
	public String FileDel(String Filename){
		String retmsg="";
		try{
			File fp1=new File(Filename);
			fp1.delete();
			retmsg="0";
		}
		catch(Exception e){
			retmsg="-1";
		}
		return retmsg;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	t@C݃`FbN
	//
	public boolean FileExist(String Filename){
		File fp=new File(Filename);
		return fp.exists();
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	t@Cޔ
	//	0:݂Ȃ 1:t@C 2:fBNg
	//
	public int FileType(String Filename){
		int retsts=0;
		File fp=new File(Filename);
		if(fp.exists()){
			retsts++;
			if(fp.isDirectory())	retsts++;
		}
		return retsts;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	t@CTCY擾
	//	-1:G[
	//
	public int FileSize(String Filename){
		int retsts=0;
		File fp=new File(Filename);
		if(FileType(Filename)!=1)	retsts=-1;
		else						retsts=(int)fp.length();
		return retsts;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	t@C\bh
	//	filename,256,1974/08/15 00:00:00\n
	//	dirname/,-1,1974/12/11 00:00:00\n
	//
	public String FileSearch(String path){
		String retmsg="",str1,str2;
		int i;
		File dir=new File(path);
		File[] files=dir.listFiles();
		for(i=0;i<files.length;i++){
			str1=files[i].getName();
			DateFormat df = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
			Date dt = new Date(files[i].lastModified());
			str2=df.format(dt);
			if(files[i].isDirectory())	str1+="/,-1,"+str2;
			else						str1+="," +Integer.toString((int)files[i].length())+","+str2;
			retmsg+=str1+"\n";
		}
		return retmsg;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	t@CXg\[g
	//		fBNg擪ɋl߂邾
	//
	public String FileSort(String data){
		StringTokenizer st1,st2;
		String retmsg="",str1,str2;
		st1=new StringTokenizer(data,"\n");
		while(st1.hasMoreTokens()){
			str1=st1.nextToken();
			st2=new StringTokenizer(str1,",");
			str2=st2.nextToken();
			st2=null;
			if(str2.endsWith("/"))	retmsg+=str1+"\n";
		}
		st1=null;
		st1=new StringTokenizer(data,"\n");
		while(st1.hasMoreTokens()){
			str1=st1.nextToken();
			st2=new StringTokenizer(str1,",");
			str2=st2.nextToken();
			st2=null;
			if(!str2.endsWith("/"))	retmsg+=str1+"\n";
		}
		st1=null;
		return retmsg;
	}
}

