public class Timer implements Runnable{
	private Thread t;
	private boolean ThreadFlag=false;
	private Timeout timeout=null;
	private int Limit=0;
	
	public void addListener(Timeout to){
		timeout=to;
	}
	
	public void start(int limit){
		if     (limit<=0)		throw new RuntimeException("TimerLimit<=0ms");
		else if(timeout==null)	throw new RuntimeException("NoTimeoutListener");
		else{
			t=new Thread(this);
			ThreadFlag=true;
			Limit=limit;
			t.start();
		}
	}
	
	public void stop(){
		ThreadFlag=false;
	}
	
	public void run(){
		while(ThreadFlag){
			try{Thread.sleep(Limit);}catch(Exception e){}
			if(ThreadFlag)	Timeout();
		}
		t=null;
	}
	
	private void Timeout(){
		timeout.timeout();
	}
}
