import java.util.*;

public class makeUserList{
	private FileTools    file;
	private CodeExchange code;
	
	private int userLimit=100;
	private int userMax  =  0;
	private String[] userName =new String[userLimit];
	private String[] userPass =new String[userLimit];
	private int[]    userLevel=new int[   userLimit];
	
	public static void main(String[] args){
		new makeUserList(args);
	}
	
	public makeUserList(String[] args){
		int i,j;
		if(args.length<2)	System.out.println("usage: makeUserList <UserListMasterFilename> <UserListFilename>");
		else{
			file=new FileTools();
			code=new CodeExchange();
			
			i= inputUserInfo(args[0]);
			j=outputUserList(args[1]);
			System.out.println("Finish.");
		}
	}
	
	private int inputUserInfo(String filename){
		int retsts=0;
		StringTokenizer st1,st2;
		String str1,str2,str3;
		int i,j,k;
		
		try{
			str1=file.FileRead(filename);
			st1=new StringTokenizer(str1,"\n");
			i=0;
			while(st1.hasMoreTokens()){
				str2=st1.nextToken();
				if(str2.startsWith("listtype=")){
				}
				else{
					try{
						st2=new StringTokenizer(str2,",");
						userName[ userMax]=st2.nextToken();
						userPass[ userMax]=st2.nextToken();
						str3=st2.nextToken();
						userLevel[userMax]=Integer.parseInt(str3);
						st2=null;
						userMax++;
					}
					catch(Exception e){}
				}
			}
			st1=null;
		}
		catch(Exception e){
			retsts=-1;
		}
		return retsts;
	}
	
	private int outputUserList(String filename){
		int retsts=0;
		char[] base64=new char[100];
		int hash;
		String str1,str2,str3;
		int i,j,k;
		
		str1="listtype=hash\n";
		for(i=0;i<userMax;i++){
			str3="";
			hash=userPass[i].hashCode();
			str1+=userName[i]+","+Integer.toString(hash)+","+Integer.toString(userLevel[i])+"\n";
		}
		file.FileWrite(filename,str1);
		return retsts;
	}
}
